#!/bin/bash
#
#  1 - Configure host and domain name and network parameters
#

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo "[$date] Configurant nom de màquina i domini per defecte:"
echo "****************************************************"

if [ -e /etc/hosts ]; then
	res=$(mv /etc/hosts /etc/hosts.orig 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: No s'ha pogut fer una copia de seguretat del fitxer /etc/hosts; $res"
	fi
fi      

res=$(cp /etc/Linkat/data/hosts.Linkat /etc/hosts 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No s'ha pogut substituir el fitxer /etc/hosts; $res"
else
	echo -en "Success: Canviat el fitxer /etc/hosts\n"
	res=$(chmod 644 /etc/hosts && chown root:root /etc/hosts 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: No s'ha pogut substituir el fitxer /etc/hosts; $res"
	fi
fi      


if [ -e /etc/HOSTNAME ]; then
	res=$(mv /etc/HOSTNAME /etc/HOSTNAME.orig 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: No s'ha pogut fer una còpia de seguretat del fitxer /etc/HOSTNAME; $res"
	fi
fi      

res=$(cp /etc/Linkat/data/HOSTNAME.Linkat /etc/HOSTNAME 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No s'ha pogut substituir el fitxer /etc/HOSTNAME; $res"
else
	echo -en "Success: Canviat el fitxer /etc/HOSTNAME\n"
	res=$(chmod 644 /etc/HOSTNAME && chown root:root /etc/HOSTNAME 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: No s'ha pogut substituir el fitxer /etc/HOSTNAME; $res"
	fi
fi

#
# Verify that everything's OK and export the corresponding vars for the rest of the scripts
#

NOM=$(cat /etc/HOSTNAME | cut -d "." -f 1)
if [ ! $? -eq 0 ]; then
	echo -en "Error:: S'ha produït un error obtenint el nom de la màquina; $res. \n Posant nom genèric \"servidor\""
	NOM="servidor"
	export $NOM
else
	export NOM
fi

export DOMINI=$(cat /etc/HOSTNAME | cut -d "." -f 2)
if [ ! $? -eq 0 ]; then
	echo -en "Error:: S'ha produit un error obtenint el domini de la màquina; $res. \n Posant domini genèric \"intracentre\""
	DOMINI="intracentre"
	export DOMINI
fi

