#!/bin/bash
#
#	5 - Set up and configure LDAP server and local LDAP client
#

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo "[$date] Instal·lant i configurant servidor LDAP:"
echo "****************************************************"

if [ "$NOM" == "" ]; then
   NOM="servidor"
fi
if [ "$DOMINI" == "" ]; then
  DOMINI="intracentre"
fi

echo -en "Guardant contrasenya del cn=Administrador:\n"

LDAP_ADMIN_PASS=$1
LDAP_PASS_FILE="/etc/Linkat/data/.passwd"

touch $LDAP_PASS_FILE && chmod 600 $LDAP_PASS_FILE
echo $LDAP_ADMIN_PASS > $LDAP_PASS_FILE


res=$(cd /etc/openldap && tar -zxvf /etc/Linkat/data/ldap_server_config.tar.gz 2>&1)
if [ ! $? -eq 0 ];then
   echo -en "Error:: No s'ha pogut substituir la configuració del servidor LDAP; $res"
else
   echo -en "Configuració del servidor LDAP instal·lada correctament\n"
fi


if [ -e /etc/ldap.conf ]; then
   res=$(cp /etc/ldap.conf /etc/ldap.conf.orig 2>&1)
   if [ ! $? -eq 0 ];then
      echo -en "Error:: No s'ha pogut fer una còpia de seguretat de la configuració del client LDAP actual; $res"
   else
      echo -en "S'ha fet una còpia de seguretat del client LDAP actual\n"
   fi
fi

if [ -e /etc/sysconfig/openldap ]; then
   res=$(mv /etc/sysconfig/openldap /etc/sysconfig/openldap.orig 2>&1)
   if [ ! $? -eq 0 ];then
      echo -en "Error:: No s'ha pogut fer una còpia de seguretat de la configuració de sistema del servidor LDAP; $res"
   fi
fi

if [ -e /etc/sysconfig/ldap ]; then
   res=$(mv /etc/sysconfig/ldap /etc/sysconfig/ldap.orig 2>&1)
   if [ ! $? -eq 0 ];then
      echo -en "Error:: No s'ha pogut fer una còpia de seguretat de la configuració de sistema de l'LDAP; $res"
   fi
fi


res=$(cp /etc/Linkat/data/sysconfig.ldap /etc/sysconfig/ldap 2>&1)
if [ ! $? -eq 0 ];then
   echo -en "Error:: No s'ha pogut substituir la configuració del servidor LDAP; $res"
else
   res=$(chmod 644 /etc/sysconfig/ldap && chown root:root /etc/sysconfig/ldap 2>&1)
   if [ ! $? -eq 0 ];then
      echo -en "Error:: No s'han pogut canviar els permisos de /etc/ldap.conf; $res"
   else
      echo -en "S'ha modificat la configuració de sistema de l'LDAP amb èxit\n"
   fi
fi


res=$(cp /etc/Linkat/data/sysconfig.openldap /etc/sysconfig/openldap 2>&1)
if [ ! $? -eq 0 ];then
   echo -en "Error:: No s'ha pogut substituir la configuració del servidor LDAP; $res"
else
   res=$(chmod 644 /etc/sysconfig/openldap && chown root:root /etc/sysconfig/openldap 2>&1)
   if [ ! $? -eq 0 ];then
      echo -en "Error:: No s'han pogut canviar els permisos de /etc/sysconfig/openldap; $res"
   else
      echo -en "S'ha modificat la configuració de sistema del servidor LDAP amb èxit\n"
   fi
fi



res=$(cp /etc/Linkat/data/ldap.conf.Linkat /etc/ldap.conf 2>&1)
if [ ! $? -eq 0 ];then
   echo -en "Error:: No s'ha pogut substituir la configuració del servidor LDAP; $res"
else
   res=$(chmod 644 /etc/ldap.conf 2>&1)
   if [ ! $? -eq 0 ];then
      echo -en "Error:: No s'han pogut canviar els permisos de /etc/ldap.conf; $res"
   else
      echo -en "S'ha modificat la configuració del client LDAP amb èxit\n"
   fi
fi

res=$(/sbin/yast2 ldap-server service enable 2>&1)
if [ ! $? -eq 0 ];then
   echo -en "Error:: No s'ha pogut habilitar el servidor LDAP; $res"
else
   res=$(/sbin/yast2 ldap-server addDatabase basedn="dc=$DOMINI" rootdn="cn=Administrator, dc=$DOMINI" password="$LDAP_ADMIN_PASS" enctype="SHA" type="hdb" dbdir="/var/lib/ldap" 2>&1 )
   if [ ! $? -eq 0 ];then
      echo -en "Error:: No s'ha pogut crear la base de dades intracentre; $res"
   else
      echo -en "S'ha creat correctament la base de dades intracentre\n"
   fi

  echo -en "Configurant el client de ldap\n"
  res=$(sed "s/__DOMINI__/$DOMINI/g" /etc/Linkat/data/ldap.client.conf | sed "s/__SERVIDOR__/$NOM/g" >/etc/openldap/ldap.conf 2>&1)
   echo -en "Important configuració del servidor LDAP\n"
   res=$(cat /etc/Linkat/data/ldapconfig.ldif | sed s/__DOMINI__/$DOMINI/g > /etc/Linkat/data/ldapconfig.ldif.Linkat 2>&1)
   res=$(ldapadd -x -h localhost -a -D "cn=Administrator,dc=$DOMINI" -w $LDAP_ADMIN_PASS -f /etc/Linkat/data/ldapconfig.ldif.Linkat 2>&1)
   if [ ! $? -eq 0 -a ! $? -eq 68 ];then
      echo -en "Error:: No s'ha pogut afegir la configuració de l'LDAP: $res";
   else
      echo -en "Success:: S'ha configurat correctament el servidor LDAP\n"
   fi
   
   echo -en "Habilitant l'autenticació d'usuaris i grups a través de l'LDAP\n"
   res=$(/sbin/yast2 ldap pam createconfig enable ldappw=$LDAP_ADMIN_PASS 2>&1)
   if [ ! $? -eq 0 ];then
      echo -en "Error:: No s'ha pogut crear l'esquema PAM a l'LDAP ; $res\n"
   else
      echo -en "S'han incorporat correctament els objectes de l'autenticació PAM a l'LDAP\n"
   fi

#######
#   This is automatically enabled by YaST when creating the LDAP PAM auth configuration, above
#######
#   echo -en "Habilitant l'autenticació PAM a l'LDAP"
#   res=$(/sbin/yast2 ldap pam enable 2>&1)
#   if [ ! $? -eq 0 ];then
#      echo -en "Error:: No s'ha pogut habilitar l'autenticació via LDAP; $res\n"
#   else
#      echo -en "Success:: S'ha habilitat correctament l'autenticació d'usuaris via LDAP\n"
#   fi


fi

echo -en "Modificant els filtres per defecte del YaST (mostrar usuaris i grups de l'LDAP)\n"
if [ -e /var/lib/YaST2/users.ycp ]; then
   res=$(mv /var/lib/YaST2/users.ycp /var/lib/YaST2/users.ycp.orig 2>&1)
   if [ ! $? -eq 0 ];then
      echo -en "Error:: No s'ha pogut fer una còpia de seguretat de la configuració de sistema de l'LDAP; $res\n"
   fi
fi

res=$(cp /etc/Linkat/data/users.ycp.Linkat /var/lib/YaST2/users.ycp 2>&1)
if [ ! $? -eq 0 ];then
   echo -en "Error:: No s'ha pogut substituir la configuració dels filtres del gestor d'usuaris del YaST; $res\n"
else
   res=$(chmod 644 /var/lib/YaST2/users.ycp && chown root:root /var/lib/YaST2/users.ycp 2>&1)
   if [ ! $? -eq 0 ];then
      echo -en "Error:: No s'han pogut canviar els permisos dels filtres de visualització d'usuaris del YaST; $res\n"
   else
      echo -en "Success:: S'ha modificat la configuració del gestor d'usuaris del YaST amb èxit\n"
   fi
fi


