#!/bin/bash
#
#       25 - Configure DNS client 
#

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo -en "[$date] Client DNS \n"
echo "****************************************************"

echo -en "Obtenint adreça de la màquina: " 

ip=$(/sbin/ifconfig | grep "inet addr" | grep -v "127.0.0.1"| awk '{print $2}' | cut -d ":" -f 2 | head -1)
if [ ! $? -eq 0 ];then
		echo -en "Error:: No s'ha pogut obtenir l'adreça de la màquina. Es farà servir l'adreça 127.0.0.1; $res"
		ip="127.0.0.1"
else
		echo -en "Ok\n"
fi

if [ -e /etc/resolv.conf ];then
	echo -en "Fent còpia de seguretat del fitxer de resolució: "
	res=$(mv /etc/resolv.conf /etc/Linkat/backup/resolv.conf.orig 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: No s'ha pogut fer una copia de seguretat de la configuració actual del DNS; $res"
	else
		echo -en "Ok\n"
	fi
fi

echo -en "Configurant el servidor de centre com servidor DNS\n"
cat /etc/Linkat/data/resolv.conf.Linkat | sed s/_IP_/$ip/g | sed s/__DOMINI__/$DOMINI/g > /etc/resolv.conf
if [ ! $? -eq 0 ];then
		echo -en "Error:: Hi ha hagut un error al aplicar la configuració del client DNS; $res"
   else
      echo -en "Success: Aplicada la configuració del client DNS"
fi

