#!/bin/bash
#
#       45 - Configure Samba server 
#
TSTAMP=`date +%Y%m%d%H%M%S`
DSTAMP=`date +%H%M%S`

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo -en "[$date] Servidor SAMBA \n"
echo "****************************************************"

echo -en "Comprovant ldap schemas antics...\n"
res=$(ls -1 /etc/openldap/slapd.d/cn\=config/cn\=schema | grep samba3 | wc -l)
if [[ $res != "0" ]];then
	echo -en "Warning: El fitxer schema de samba3 ja es troba al servidor."
else
	echo -en "S'està instal·lant el fitxer schema de samba3..."
	COUNT=`ls -1 /etc/openldap/slapd.d/cn\=config/cn\=schema | sort | tr "{" " " | tr "}" " "  | cut -d" " -f 2 | tail -n 1`
	COUNT=`expr $COUNT + 1`
	res=$(cat /etc/Linkat/data/cn\=\{_\}samba3.ldif | \
		sed s/__ORD__/$COUNT/g | \
		sed s/__TIMESTAMP__/$TSTAMP/g | \
		sed s/__DATESTAMP__/$DSTAMP/g \
		>/etc/openldap/slapd.d/cn\=config/cn\=schema/cn\=\{$COUNT\}samba3.ldif 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error: S'ha produït un error al copiar el fitxer schema del samba3."
	else
		echo -en "Ok\n"
	fi
	res=$(chown ldap.ldap /etc/openldap/slapd.d/cn\=config/cn\=schema/cn\=\{$COUNT\}samba3.ldif 2>&1)
        if [ ! $? -eq 0 ];then
                echo -en "Error: S'ha produït un error al canviar el propietari del schema.\n"
	else
		echo -en "Ok\n"
	fi
fi

res=$(chown -R ldap.ldap /etc/openldap/schema 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error: S'ha produït un error al canviar el propietari del directori schema.\n"
else
	echo -en "Ok\n"
fi
res=$(chown ldap.ldap /etc/openldap/slapd.conf 2>&1)
if [ ! $? -eq 0 ];then
        echo -en "Error: S'ha produït un error al canviar el propietari del fitxer slapd.conf .\n"
else
	echo -en "Ok\n"
fi

res_code=0
echo -en "S'estan aplicant canvis al servidor LDAP\n"
res=$(rcldap status 2>&1)
case $? in
	1)
		res=$(rcldap start 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	3)
		res=$(rcldap start 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	0)
		res=$(rcldap reload 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	*)
		res=$(rcldap reload 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
esac

if [ -e /etc/apparmor.d/usr.sbin.smbd ];then
                echo -en "Crear còpia de seguretat de la configuració de Samba a Apparmor: "
                res=$(cp /etc/apparmor.d/usr.sbin.smbd /etc/Linkat/backup/usr.sbin.smbd.orig 2>&1)
                if [ ! $? -eq 0 ];then
                        echo -en "Error:: S'ha produït un error al crear la còpia de seguretat de Samba de Apparmor: $res"
                else
                        res=$(sed 's/\/usr\/sbin\/smbd/\/usr\/sbin\/smbd\ flags=(complain)/g' /etc/apparmor.d/usr.sbin.smbd > /etc/apparmor.d/usr.sbin.smbd 2>&1)
			if [ ! $? -eq 0 ];then
				echo -en "Error:: S'ha produit un error al canviar la configuració de Samba a Apparmor: $res"
			else
				echo -en "OK:: Configuració de Samba a Apparmor modificada.\n"
			fi
                fi
fi

if [ -e /etc/apparmor.d/usr.sbin.nmbd ];then
                echo -en "Crear còpia de seguretat de la configuració de Samba NMB a Apparmor: "
                res=$(cp /etc/apparmor.d/usr.sbin.nmbd /etc/Linkat/backup/usr.sbin.nmbd.orig 2>&1)
                if [ ! $? -eq 0 ];then
                        echo -en "Error:: S'ha produït un error al crear la còpia de seguretat de Samba NMB de Apparmor: $res"
                else
                        res=$(sed 's/\/usr\/sbin\/nmbd/\/usr\/sbin\/nmbd\ flags=(complain)/g' /etc/apparmor.d/usr.sbin.nmbd > /etc/apparmor.d/usr.sbin.nmbd 2>&1)
                        if [ ! $? -eq 0 ];then
                                echo -en "Error:: S'ha produit un error al canviar la configuració de Samba NMB a Apparmor: $res"
                        else
                                echo -en "OK:: Configuració de Samba NMB a Apparmor modificada.\n"
                        fi
                fi
fi

echo -en "Reiniciant el servei Apparmor: "
res_code=0
res=$(rcapparmor status 2>&1)
case $? in
     3)
       res=$(rcapparmor start 2>&1)
       if [ ! $? -eq 0 ];then
          res_code=1
       fi
     ;;
     1)
       res=$(rcapparmor start 2>&1)
       if [ ! $? -eq 0 ];then
          res_code=1
       fi
     ;;
     0)
       res=$(rcapparmor restart 2>&1)
       if [ ! $? -eq 0 ];then
          res_code=1
       fi
     ;;
     *)
       res_code=1
     ;;
esac
if [ $res_code -ne 0 ];then
   echo -en "Error:: S'ha produït un error durant l'arrencada del servei Apparmor  : $res"
else
   echo -en "OK:: Apparmor reiniciat correctament"
fi


if [ -e /etc/samba/smb.conf ];then
		echo -en "Crear còpia de seguretat de la configuració actual de samba: "
		res=$(mv /etc/samba/smb.conf /etc/Linkat/backup/smb.conf.orig 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Error:: S'ha produït un error al aplicar els canvis del servidor Samba: $res"
		else
			echo -en "Ok\n"
		fi
fi

echo -en "Aplicant configuració de Linkat: "
res=$(cat /etc/Linkat/data/smb.conf.Linkat | sed s/__NOM__/$NOM/g | sed s/__DOMINI__/$DOMINI/g > /etc/samba/smb.conf 2>&1)
if [ ! $? -eq 0 ];then
		echo -en "Error:: S'ha produït un error al aplicar els canvis del servidor Samba: $res"
	else
		echo -en "Ok\n"
		if [ -e /etc/samba/secrets.tdb ];then
			echo -en "Creant còpia de seguretat de fitxers secrets.tdb\n"
			res=$(mv /etc/samba/secrets.tdb /etc/Linkat/backup/secrets.tdb.orig 2>&1)
			if [ ! $? -eq 0 ];then
				echo -en "Error:: S'ha produït un error al fer una còpia de seguretat del fitxer secrets.tdb:$res"
			else
				echo -en "Ok\n"
			fi
		fi

      pass=$(cat /etc/Linkat/data/.passwd)
      if [ "x$pass" == "x" ]; then 
         # This should *never* happen, but we'll try to fail gracefully: we'll assume "secret" as the 
         # LDAP cn=Administrador password and try to keep going
			echo -en "Error:: No s'ha trobat la contrasenya d'administrador del servidor LDAP"
         pass="secret"
	   fi


      res=$(smbpasswd -w $pass)
		echo -en "Aplicant la configuració de samba al servidor LDAP: "
		if [ ! $? -eq 0 ];then
			echo -en "Error:: S'ha produït un error al aplicar els canvis dels passwords de Samba: $res"
			pass=""
		else
			echo -en "Ok\n"  
			echo -en "Reiniciant el servei SMB: "
			res_code=0
			res=$(rcsmb status 2>&1)
			case $? in
				3)
					res=$(rcsmb start 2>&1)
					if [ ! $? -eq 0 ];then
						res_code=1
					fi
				;;
				1)
					res=$(rcsmb start 2>&1)
					if [ ! $? -eq 0 ];then
						res_code=1
					fi
				;;
				0)
					res=$(rcsmb restart 2>&1)
					if [ ! $? -eq 0 ];then
						res_code=1
					fi
				;;
				*)
					res_code=1
				;;
			esac
			if [ $res_code -ne 0 ];then
				echo -en "Error:: S'ha produït un error durant l'arrencada del servei Samba SMB : $res"
			else
				echo -en "Ok\n"
				code=0
				echo "S'està afegint servei smbd a la seqüència d'inici: "
				res=$(chkconfig --add smb 2>&1)
				if [ ! $? -eq 0 ];then
					echo -en "Error:: No s'ha pogut afegir el servei Samba SMB a la seqüència d'inici: $res"
				else
					echo -en "Ok\n"
				fi
			fi
			echo -en "Reiniciant el servei NMB: "
			res_code=0
			res=$(rcnmb status 2>&1)
			case $? in
				3)
					res=$(rcnmb start 2>&1)
					if [ ! $? -eq 0 ];then
						res_code=1
					fi
				;;
				1)
					res=$(rcnmb start 2>&1)
					if [ ! $? -eq 0 ];then
						res_code=1
					fi
				;;
				0)
					res=$(rcnmb restart 2>&1)
					if [ ! $? -eq 0 ];then
						res_code=1
					fi
				;;
				*)
					res_code=1
				;;
			esac
			if [ $res_code -ne 0 ];then
				echo -en "Error:: S'ha produït un error al aplicar els canvis del servidor Samba: $res"
			else
				echo -en "Ok\n"
				code=0
				echo "S'està afegint servei nmbd a la seqüència d'inici: "
				res=$(chkconfig --add nmb 2>&1)
				if [ ! $? -eq 0 ];then
					echo -en "Error:: No s'ha pogut afegir el servei Samba NMB a la seqüència d'inici: $res"
				else
					echo -en "Ok\n"
				fi
			fi
		fi
fi

