#!/bin/bash
#
#       50 - Configure LDAP groups 
#

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo "[$date] Afegint grups LDAP"
echo "****************************************************"

if [ "$NOM" == "" ]; then
   NOM="servidor"
fi
if [ "$DOMINI" == "" ]; then
  DOMINI="intracentre"
fi

if [ "x$pass" == "x" ]; then
   # This should *never* happen, but we'll try to fail gracefully  
   pass=$(cat /etc/Linkat/data/.passwd)
   if [ "x$pass" == "x" ]; then
      # Ok, last shot, we'll assume "secret" as the LDAP cn=Administrador password and try to keep going
      echo -en "Error:: No s'ha trobat la contrasenya d'administrador del servidor LDAP"
      pass="secret"
   fi
fi

res=$(ldapsearch -x -D cn=Administrator,dc=$DOMINI -b dc=$DOMINI -s sub  "cn=Alumnat" -w $pass | grep "cn: Alumnat" | wc -l)
if [ $res -eq 0 ]; then
	echo -en "No existeix el grup Alumnat. OK, creant estructura de grups...\n"
	res=$(cat /etc/Linkat/data/grups.ldif | sed s/__DOMINI__/$DOMINI/g > /etc/Linkat/data/grups.ldif.Linkat 2>&1)
	res=$(ldapadd -x -h localhost -a -D "cn=Administrator,dc=$DOMINI" -w $pass -f /etc/Linkat/data/grups.ldif.Linkat 2>&1)
	echo "ldapadd -x -h localhost -a -D \"cn=Administrator,dc=$DOMINI\" -w $pass -f /etc/Linkat/data/grups.ldif.Linkat" >> /tmp/debug
	if [ ! $? -eq 0 -a ! $? -eq 68 ];then
		echo -en "Error:: No s'han pogut crear els grups LDAP: $res\n";
	else
		echo -en "Success:: S'han afegit correctament els grups d'un centre educatiu al servidor LDAP\n"
	fi
fi
