#!/bin/bash
#
#       60 - Configure NFS server 
#

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo -en "[$date] Servidor NFS \n"
echo "****************************************************"

echo -en "S'està fent una còpia de seguretat de la configuració NFS /etc/sysconfig/nfs: "

if [ -e /etc/sysconfig/nfs ];then
        res=$(cp /etc/sysconfig/nfs /etc/Linkat/backup/nfs.orig 2>&1)
        if [ ! $? -eq 0 ];then
                echo -en "Error:: S'ha produït un error al fer la còpia de seguretat del fitxer /etc/sysconfig/nfs; $res"
        else
                echo -en "Ok\n"
        fi
fi

echo -en "S'està configurant /etc/sysconfig/nfs: "
res=$(cp /etc/Linkat/data/sysconfig.nfs /etc/sysconfig/nfs 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: S'ha produït un error al copiar el fitxer /etc/sysconfig/nfs; $res"
else
	echo -en "Ok\n"
fi

echo -en "S'està fent la còpia de seguretat del fitxer /etc/exports: "
if [ -e /etc/exports ];then
		res=$(cp /etc/exports /etc/Linkat/backup/exports.orig 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Error: No s'ha pogut fer una còpia de seguretat de la configuració NFS: $res"
		else
			echo -en "Ok\n"
		fi
fi

echo -en "S'està aplicant la configuració NFS de Linkat: \n"
res=$(cp -f /etc/Linkat/data/exports.Linkat /etc/exports 2>&1)
if [ ! $? -eq 0 ];then
		echo -en "Error:: S'ha produit un error aplicant la configuració del servidor NFS: $res"
	else
		echo -en "S'estan establint els permisos: "
		res=$(chmod 644 /etc/exports 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Error:: No s'ha pogut establir permisos adients al fitxer de configuració del servidor NFS: $res"
		else
			echo -en "Ok\n"
		fi
fi


echo -en "S'estan aplicant els canvis al servidor NFS: "
res=$(rcrpcbind restart)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No s'ha pogut reiniciar el servei rpcbind: $res"
else
	echo -en "Ok\n"
fi

res_code=0
res=$(rcnfsserver status 2>&1)
case $? in
	3)
		res=$(rcnfsserver restart 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	0)
		res=$(rcnfsserver restart 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	*)
		res_code=1
esac
                
echo -en "S'està afegint el servidor NFS a la seqüència d'init: "
res=$(chkconfig --add nfsserver 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No s'ha pogut posar el servei NFS a la seqüència d'init"
else
	echo -en "Success:: Servidor NFS configurat correctament\n"
fi      

