#!/bin/bash
#
#       70 - Configure JClic reports
#

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo "[$date] Configuració JClic Reports"
echo "****************************************************"
res_code=0
res=$(chkconfig --add mysql 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No s'ha pogut posar el servei Mysql a la seqüència d'init\n"
	err_code=1
else
	echo -en "Warning:: S'ha posat el servei Mysql a la seqüència d'init \n\t$res\n"
fi

res_code=0
res=$(rcmysql status 2>&1)
case $? in
	3)
		res=$(rcmysql start 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	0)
		res=$(rcmysql restart 2>&1)
		if [ ! $? -eq 0 ];then	
			res_code=1
		fi
	;;
	*)
	res_code=1
	;;
esac

# pass

if [ $res_code -ne 0 ];then
	echo "Error:: S'ha produït un error al aplicar els canvis del servidor Mysql: $res"
else
	sleep 5
	err_code=0
	existeix=0
	export pass=`cat /etc/Linkat/data/.passwd`
	res=$(mysql --user=root < /etc/Linkat/data/create_database.sql 2>&1)
	if [ ! $? -eq 0 ];then
		res=$(echo $res | grep -i "database exist" 2>&1)
		if [ ! $? -eq 0 ];then 
			echo "Error:: No s'ha pogut crear la base de dades JClicReports; $res"
			err_code=1
		else
			existeix=1
		fi
	fi

	if [ $err_code -eq 0 ];then
		res=$(cat /etc/Linkat/data/permisos.sql | sed s/__PASSWORD__/$pass/g | mysql --user=root 2>&1)
		if [ ! $? -eq 0 ];then
			echo "Error:: No s'han pogut establir els permisos de la base de dades JClicReports i de l'administrador de Mysql; $res"
			export pass=""
		else
			if [ $existeix -eq 0 ];then
				res=$(mysql --user=jclic_user --password=linkat JClicReports < /etc/Linkat/data/jclic_test_mysql.sql 2>&1)
				if [ ! $? -eq 0 ];then
					echo "Error:: S'han afegit les dades de test; $res"
					export pass=""
					err_code=1
				else
					echo -en "Warning:: S'ha creat la base de dades JClicReports amb usuari: jclic_user \n"
					export pass=""
				fi
			fi
		fi
	fi
fi

res_code=0
res=$(rcmysql status 2>&1)
case $? in
        3)
                res=$(rcmysql start 2>&1)
                if [ ! $? -eq 0 ];then
                        res_code=1
                fi
        ;;
        0)
                res=$(rcmysql restart 2>&1)
                if [ ! $? -eq 0 ];then
                        res_code=1
                fi
        ;;
        *)
        res_code=1
        ;;
esac


res=$(chown -R tomcat.tomcat /usr/share/tomcat6 2>&1)
if [ ! $? -eq 0 ];then
	echo "Error:: No s'han pogut establir els permissos del directori del tomcat"
	err_code=1
fi

res_code=0
res=$(chkconfig --add tomcat6 2>&1)
if [ ! $? -eq 0 ];then
	echo "Error:: No s'ha pogut posar el servei Tomcat a la seqüència d'init"
	err_code=1
else
	echo -en "Warning:: S'ha posat el servei Tomcat a la seqüència d'init \n\t$res\n"
fi

res_code=0
res=$(cp /etc/Linkat/data/jclicReports.properties /usr/share/tomcat6/ 2>&1)
if [ ! $? -eq 0 ];then
	echo "Error:: S'ha produit un error al copiar la configuració del servidor d'informes"
else
	res=$(chown tomcat.tomcat /usr/share/tomcat6/jclicReports.properties 2>&1)
	if [ ! $? -eq 0 ];then
		echo "Error:: S'ha produit un error al establir els permissos del fitxer de configuració del servidor d'informes; $res\n"
	fi
fi

if [ -e /usr/share/java/mysql-connector-java.jar ];then
	if [ -e /usr/share/tomcat6/common/lib/mysql-connector-java.jar ];then
		res=$(rm -rf /usr/share/tomcat6/common/lib/mysql-connector-java.jar 2>&1)
		if [ ! $? -eq 0 ];then
			echo "Error:: S'ha produit un error esborrant mysql-connector-java.jar"
		fi
	fi

	res=$(ln -s /usr/share/java/mysql-connector-java.jar /usr/share/java/tomcat6 2>&1)
	if [ ! $? -eq 0 ];then
		echo "Error:: S'ha produit un error al instal·lar el connector JDBC per Mysql; $res\n"
	else
		echo "Warning:: S'ha instal·lat el connector JDBC per Mysql; $res"
        fi
else
	echo "Error:: No existeix /usr/share/java/mysql-connector-java.jar"
fi


res_code=0
res=$(rctomcat6 status 2>&1)
case $? in
	3)
		res=$(rctomcat6 start 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	0)
		res=$(rctomcat6 restart 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	*)
		res_code=1
	;;
esac

if [ $res_code -ne 0 ];then
	echo "Error:: S'ha produït un error al aplicar els canvis del servidor Tomcat: $res"
fi

res_code=0
res=$(cp /etc/Linkat/data/tomcat-users.xml /etc/tomcat6/tomcat-users.xml 2>&1)
if [ ! $? -eq 0 ];then
	echo "Error:: S'ha produit un error al crear l'usuari administrdor de Tomcat"
	err_code=1
else
	echo -en "Warning:: S'ha creat l'usuari administrador de Tomcat:\n\t\t usuari: linkat \n\t\t contrasenya: linkat \n\t per canviar la contrasenya editeu el fitxer /etc/tomcat6/tomcat-users.xml o des de l'administrador\n"
fi


