#!/bin/bash
#
#       85 - Linkat Updates
#

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo "[$date] Setting up linkat updates system and local repo"
echo "****************************************************"


case $CLIENT_VERSION in 
	2)
		echo "#Actualitzacions Linkat 2"
		res=$(cp /etc/sysconfig/cron /etc/Linkat/backup/sysconfig.cron.orig 2>&1)
		if [ ! $? -eq 0 ];then
			echo -e "Error:: No s'ha pogut fer la còpia de seguretat del fitxer cron; $res"
		else
			echo -e "Success: Copia de sysconfig completada correctament" 
		fi
	
		res=$(cp /etc/Linkat/data/sysconfig.cron /etc/sysconfig/cron 2>&1)
		if [ ! $? -eq 0 ];then
			echo -e "Error:: No s'ha pogut instal·lar la configuració del servei cron; $res"
		else
			echo -e "Success: Copia de sysconfig completada correctament" 
		fi

		res=$(cp /etc/Linkat/data/update_linkat_2.sh /etc/cron.daily 2>&1)
		if [ ! $? -eq 0 ];then
			echo -e "Error:: No s'ha pogut copiar l'script d'actualitzacions; $res"
		else
			echo -e "Success: Copia del fitxer update_linkat_2.sh"
		fi

		res=$(mkdir -p /srv/www/htdocs/linkat2/distribution/linkat-2.0/inst-source/ 2>&1)
		if [ ! $? -eq 0 ];then
			echo -e "Error:: Problemes creant directori inst-source; $res"
		else
			echo -e "Success: S'ha creat el directori inst-source correntament" 
			res=$(chmod 755 /srv/www/htdocs/linkat2/distribution/linkat-2.0/inst-source 2>&1)
			if [ ! $? -eq 0 ];then
				echo -e "Error:: Problemes establint permisos a inst-source; $res"
			else
				echo -e "Success: S'han cambiat els permisos al directori inst-source correctament" 
			fi
		fi
	
		res=$(mkdir -p /srv/www/htdocs/linkat2/distribution/linkat-2.0/repo 2>&1)
		if [ ! $? -eq 0 ];then
			echo -e "Error:: Problemes creant directori repo; $res"
		else
			echo -e "Success: S'ha creat el directori repo correntament"
		fi

		res=$(cp /etc/Linkat/data/repo-server-linkat2.conf /etc/apache2/conf.d/repo-server-linkat2.conf 2>&1)	
		if [ ! $? -eq 0 ];then
			echo -e "Error:: No s'ha pogut copiar la configuració http; $res"
		else
			echo -e "Success: S'ha copiat la configuració http."
		fi
       	 
		res=$(tar zxvf /etc/Linkat/data/repo_linkat_2.tar.gz -C /srv/www/htdocs/linkat2/distribution/linkat-2.0/  2>&1)
		if [ ! $? -eq 0 ];then
			echo -e "Error:: Descomprimint repo_linkat_2.tar.gz $res"
		else
			echo -e "Ok\n"
			echo -e "Success: S'ha descomprimit el fitxer repo_linkat_2.tar.gz correctament" 
		fi
       	 
		res=$(chown -R wwwrun.www /srv/www/htdocs/linkat2/distribution  2>&1)
		if [ ! $? -eq 0 ];then
			echo -e "Error:: Canviant el propietari de /srv/www/htdocs/linkat2/distribution; $res"
		else
			echo -e "Success: S'ha cambiat el propietari de /srv/www/htdocs/linkat2/distribution correctament" 
		fi
	;;
	3)
		echo "#Actualitzacions Linkat 3"
		res=$(cp /etc/sysconfig/cron /etc/Linkat/backup/sysconfig.cron.orig 2>&1)
		if [ ! $? -eq 0 ];then
			echo -e "Error:: No s'ha pogut fer la còpia de seguretat del fitxer cron; $res"
		else
			echo -e "Success: Copia de sysconfig completada correctament" 
		fi
        
		res=$(cp /etc/Linkat/data/sysconfig.cron /etc/sysconfig/cron 2>&1)
		if [ ! $? -eq 0 ];then
			echo -e "Error:: No s'ha pogut instal·lar la configuració del servei cron; $res"
		else
			echo -e "Success: Copia de sysconfig completada correctament" 
		fi

      res=$(cp /etc/Linkat/data/update_linkat_3.sh /etc/cron.daily 2>&1)
		if [ ! $? -eq 0 ];then
			echo -e "Error:: No s'ha pogut copiar l'script d'actualitzacions; $res"
		else
			echo -e "Success: Copia del fitxer update_linkat_3.sh"
		fi

		res=$(mkdir -p /srv/www/htdocs/linkat3/distribution/linkat-3.0/inst-source/ 2>&1)
		if [ ! $? -eq 0 ];then
			echo -e "Error:: Problemes creant directori inst-source; $res"
		else
			echo -e "Success: S'ha creat el directori inst-source correntament" 

			res=$(chmod 755 /srv/www/htdocs/linkat3/distribution/linkat-3.0/inst-source 2>&1)
			if [ ! $? -eq 0 ];then
				echo -e "Error:: Problemes establint permisos a inst-source; $res"
			else
				echo -e "Success: S'han cambiat els permisos al directori inst-source correctament" 
			fi
		fi
        
		res=$(cp /etc/Linkat/data/repo-server-linkat3.conf /etc/apache2/conf.d/repo-server-linkat3.conf 2>&1)   
      if [ ! $? -eq 0 ];then
              echo -e "Error:: No s'ha pogut copiar la configuració http; $res"
      else
              echo -e "Success: S'ha copiat la configuració http."
      fi


		res=$(mkdir -p /srv/www/htdocs/linkat3/distribution/linkat-3.0/updates 2>&1)
		if [ ! $? -eq 0 ];then
			echo -e "Error:: Problemes creant directori repo updates; $res"
		else
			echo -e "Success: S'ha creat el directori repo updates correntament"
		fi
        
         
		res=$(tar zxvf /etc/Linkat/data/repo_linkat_3.tar.gz -C /srv/www/htdocs/linkat3/distribution/linkat-3.0/updates/  2>&1)
		if [ ! $? -eq 0 ];then
			echo -e "Error:: Descomprimint repo_linkat_3.tar.gz; $res"
		else
			echo -e "Success: S'ha descomprimit el fitxer repo_linkat_3.tar.gz correctament" 
		fi

		res=$(mkdir -p /srv/www/htdocs/linkat3/distribution/linkat-3.0/openSUSE_11.1 2>&1)
		if [ ! $? -eq 0 ];then
			echo -e "Error:: Problemes creant directori repo openSUSE updates; $res"
		else
			echo -e "Success: S'ha creat el directori repo openSUSE updates correntament"
		fi
        
         
		res=$(tar zxvf /etc/Linkat/data/repo_linkat_3.tar.gz -C /srv/www/htdocs/linkat3/distribution/linkat-3.0/openSUSE_11.1/  2>&1)
		if [ ! $? -eq 0 ];then
			echo -e "Error:: Descomprimint repo_linkat_3.tar.gz; $res"
		else
			echo -e "Success: S'ha descomprimit el fitxer repo_linkat_3.tar.gz correctament" 
		fi
         
		res=$(chown -R wwwrun.www /srv/www/htdocs/linkat3/distribution  2>&1)
		if [ ! $? -eq 0 ];then
			echo -e "Error:: Canviant el propietari de /srv/www/htdocs/linkat3/distribution; $res"
		else
			echo -e "Success: S'ha cambiat el propietari de /srv/www/htdocs/linkat3/distribution correctament" 
		fi
        ;;
   4)
      # A local mirror of Linkat repositories is not supported from Linkat onwards,
      # so make sure that you have a proper proxy in your network!
      echo -e "Atenció: no es crearà ha una còpia local dels repositoris per Linkat!"
   ;;
	*)
		echo -e "No s'ha escollit correctament la versió del client."
	;;
esac

res=$(/usr/sbin/rccron status 2>&1)
case $? in
	3)
		res=$(rccron start 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	0)
		res=$(rccron restart 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	*)
		res_code=1
	;;
esac
			
