#!/bin/bash
#
#       87 - Clamav instalation  
#

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo -en "[$date] Instal·lacio de CLAMAV \n"
echo "****************************************************"


##Creating quarantine folder...

res_code=0
if [ ! -e /tmp/viruses ];then
	echo -en "S'està creant el directori /tmp/viruses... "
	res=$(mkdir -m 777 /tmp/viruses 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: S'ha produït un error al crear el directori /tmp/viruses ; $res\n"
		res_code=1
	else
		echo -en "Succeed:Ok, creada la carpeta /tmp/viruses\n"
	fi
else
	echo -en "S'estan establint els permisos del directori d'unitats compartides...\n"
	res=$(chmod 777 /tmp/viruses 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: S'ha produït un error al establir els permisos del directori /tmp/viruses ; $res\n"
		res_code=1
	else
		echo -en "Succeed: Ok, s'han establert els permisos de la carpeta /tmp/viruses \n"
	fi
fi

if [ ! -e /var/log/clamav ];then
	echo -en "S'està creant el directori /var/log/clamav "
	res=$(mkdir -m 755 /var/log/clamav 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: S'ha produït un error al crear el directori /var/log/clamav ; $res\n"
		res_code=1
	else
		echo -en "Succeed:Ok, creada la carpeta /var/log/clamav \n"
	fi
fi

res=$(touch /var/log/clamav/freshclam.log 2>&1)		
if [ ! $? -eq 0 ];then
	echo -en "Error:: S'ha produït un error a /var/log/clamav/freshclamav.log ; $res\n"
	res_code=1
else
	echo -en "Succeed: Ok, creat /var/log/clamav/freshclamav.log \n"
	res1=$(chown vscan.vscan /var/log/clamav/freshclam.log 2>&1) 
fi


### Copying svs config files...

res=$(cp /etc/Linkat/data/svs.ini.Linkat /etc/samba/svs.ini 2>&1)

if [ ! $? -eq 0 ]; then
	echo -en "Error:: S'ha produït un error al copiar el fitxer de configuracio de SVS ; $res\n"
else
	echo -en "Succeed: El fitxers de SVS s'han copiat correctament\n"
fi

## Registering services...

res=$(chkconfig --add clamd 2>&1)
if [ ! $? -eq 0 ];then
        echo "Error:: No s'ha pogut posar el servei lamd la seqüència d'init"
        err_code=1
else
        echo -en "Succeed: S'ha posat el servei clamd a la seqüència d'init \n\t$res\n"
fi

res=$(rcclamd status 2>&1)
case $? in
	1)
		res=$(rcclamd start 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	3)
		res=$(rcclamd start 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	0)
		res=$(rcclamd reload 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	*)
		res=$(rcclamd reload 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
esac

res=$(chkconfig --add freshclam 2>&1)
if [ ! $? -eq 0 ];then
        echo "Error:: No s'ha pogut posar el servei fresclam la seqüència d'init"
        err_code=1
else
        echo -en "Succeed: S'ha posat el servei freshclam a la seqüència d'init \n\t$res\n"
fi

res=$(rcfreshclam status 2>&1)
case $? in
	1)
		res=$(rcfreshclam start 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	3)
		res=$(rcfreshclam start 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	0)
		res=$(rcfreshclam reload 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	*)
		res=$(rcfreshclam reload 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
esac


###Configuring clamd.conf file###

res=$(cp /etc/Linkat/data/clamd.conf.Linkat /etc/clamd.conf 2>&1)
if [ ! $? -eq 0 ]; then
        echo -en "Error:: No s'ha instal·lat el clamd.conf correctament ; $res\n"
else
        echo -en "Succeed: El fitxer clamd.conf ha estat copiat correctament\n"
fi

## Establishing the cron jobs ...

res=$(cp /etc/Linkat/data/freshclam.Linkat /etc/cron.daily/freshclam 2>&1)
if [ ! $? -eq 0 ]; then
	echo -en "Error:: No s'ha instal·lat el cron-job freshclam ; $res\n"
else
	echo -en "Succeed: Cron-job freshclam correctament\n"
	res=$(chmod 755 /etc/cron.daily/freshclam 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: S'ha produït un error al establir els permisos de freshclam ; $res\n"
		res_code=1
	else
		echo -en "Succeed: Ok, s'han establert els permisos de freshclam \n"
	fi
fi


res=$(cp /etc/Linkat/data/erase_tmp.Linkat /etc/cron.weekly/erase_tmp 2>&1)
if [ ! $? -eq 0 ]; then
	echo -en "Error:: No s'ha instal·lat el cron-job erase_tmp ; $res\n"
else
	echo -en "Succeed: Cron-job erase_tmp correctament\n"
	res=$(chmod 755 /etc/cron.weekly/erase_tmp 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: S'ha produït un error al establir els permisos de erase_tmp ; $res\n"
		res_code=1
	else
		echo -en "Succeed: Ok, s'han establert els permisos de erase_tmp \n"
	fi
fi










