#!/bin/bash
#
#       91 - Configure Owncloud
#


export pass=`cat /etc/Linkat/data/.passwd`
domini=$(cat /etc/HOSTNAME | cut -d "." -f 2)
machine=$(cat /etc/HOSTNAME)

res=$(mysql --user=root -p$pass < /etc/Linkat/data/create_database_oc.sql 2>&1)
	if [ ! $? -eq 0 ];then
		res=$(echo $res | grep -i "database exist" 2>&1)
		if [ ! $? -eq 0 ];then 
			echo "Error:: No s'ha pogut crear la base de dades owncloud; $res"
			err_code=1
		else
			echo "Succeed: La BBDD a estat creada correctament \n"
		fi
	fi

#### Carreguem la BBDD#####

res=$(cat /etc/Linkat/data/permisos_oc.sql | mysql --user=root -p$pass 2>&1)

res=$(sed s/__DOMINI__/$domini/g /etc/Linkat/data/owncloud.sql | mysql --user=owncloud --password=owncloud owncloud 2>&1)

if [ ! $? -eq 0 ];then
	echo "Error:: No ha estat possible afegir la BBDD owncloud; $res"
else
	echo -en "Succeed:: S'ha creat la base de dades owncloud amb usuari: owncloud \n"
fi

## Reiniciem el servei mysql.....

res_code=0
res=$(rcmysql status 2>&1)
case $? in
	3)
		res=$(rcmysql start 2>&1)
		if [ ! $? -eq 0 ];then
			res_code=1
		fi
	;;
	0)
		res=$(rcmysql restart 2>&1)
		if [ ! $? -eq 0 ];then	
			res_code=1
		fi
	;;
	*)
	res_code=1
	;;
esac


## Carreguem el fitxer de configuració de owncloud.....

res=$(cp /etc/Linkat/data/config.php.owncloud /srv/www/htdocs/owncloud/config/config.php 2>&1)
if [ ! $? -eq 0 ];then
	echo "Error:: No ha estat possible copiar el fitxer de configuracio de owncloud; $res"
else
	echo -en "Succeed:: Fitxer de configuració d'owncloud carregat correctament \n"
fi


res=$(chown wwwrun.www /srv/www/htdocs/owncloud/config/config.php 2>&1)
if [ ! $? -eq 0 ];then
	echo "Error:: No ha estat possible copiar els permisos del fitxer de configuracio de owncloud; $res"
else
	echo -en "Succeed:: Permisos establerts correctament \n"
fi

## ADDED for OWNCLOUD 5 + HTTPS

### APACHE2 FILES 
res=$(cp /etc/Linkat/data/apache2.Linkat /etc/sysconfig/apache2 2>&1)
if [ ! $? -eq 0 ];then
	echo "Error:: Fitxer de configuracio apache per HTTPS no copiat; $res"
else
	echo -en "Succeed:: Fitxer apache per HTTPS correcte. \n"
fi

res=$(cp /etc/Linkat/data/listen.conf.Linkat /etc/apache2/listen.conf 2>&1)
if [ ! $? -eq 0 ];then
	echo "Error:: No s'ha pogut modificar el port a ecoltar HTTPS (10443); $res"
else
	echo -en "Succeed:: Port per HTTP 10443 configurat correctament. \n"
fi

res=$(cp /etc/Linkat/data/.htaccess.Linkat /srv/www/htdocs/owncloud/data/.htaccess 2>&1)
if [ ! $? -eq 0 ];then
        echo "Error:: No s'ha pogut protegir el directori DATA; $res"
else
        res1=$(chown wwwrun.www /srv/www/htdocs/owncloud/data/.htaccess 2>&1)
	echo -en "Succeed:: Directori data protegit correctament. \n"
	
fi


res=$(sed -i s/__DOMINI__/$machine/g /etc/Linkat/data/owncloud-ssl.conf 2>&1)
if [ ! $? -eq 0 ];then
        echo "Error:: No s'ha pogut modificar el TEMPLATE del domini; $res"
else
        echo -en "Succeed:: TEMPLATE del domini al fitxer de configuracio owncloud-ssl correcte. \n"
fi

res=$(cp /etc/Linkat/data/owncloud-ssl.conf /etc/apache2/vhosts.d/owncloud-ssl.conf 2>&1)
if [ ! $? -eq 0 ];then
        echo "Error:: Impossible crear el virtual host per owncloud; $res"
else
        echo -en "Succeed:: Virtual Host configurat correctament. \n"
fi



### CREACIO DE CERTIFICATS...

res=$(/usr/bin/gensslcert -C "owncloud2" -N "Certificat owncloud" -c ES -s Barcelona -l "Barcelona" -o "Departament Ensenyament." -u "Generalitat de Catalunya" -e "linkat@xtec.cat" -y 3600  2>&1)
if [ ! $? -eq 0 ];then
	echo "Error:: El certificat no ha estat creat ; $res"
else
	echo -en "Succeed:: Certificat correcte. \n"
fi

